"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var FirebaseApi_1 = __importDefault(require("./FirebaseApi"));
var bindable_bloc_1 = require("bindable-bloc");
var FirebaseStreamableDataApi = /** @class */ (function (_super) {
    __extends(FirebaseStreamableDataApi, _super);
    function FirebaseStreamableDataApi() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.streamedData = new bindable_bloc_1.Bindable(null);
        _this.streamCanceller = null;
        return _this;
    }
    FirebaseStreamableDataApi.prototype.startStream = function () {
        var _this = this;
        this.stopStream();
        this.getReference().onSnapshot(function (snapshot) { return _this.onSnapshot(snapshot); });
    };
    FirebaseStreamableDataApi.prototype.stopStream = function () {
        if (this.streamCanceller !== null) {
            this.streamCanceller();
            this.streamCanceller = null;
        }
    };
    /**
     * Event called when the new stream of data has been received.
     */
    FirebaseStreamableDataApi.prototype.onSnapshot = function (snapshot) {
        this.streamedData.value = snapshot.exists ? this.parseData(snapshot) : null;
    };
    return FirebaseStreamableDataApi;
}(FirebaseApi_1.default));
exports.default = FirebaseStreamableDataApi;
